﻿Imports System
Imports System.Threading
Imports System.IO.Ports

Public Class Form1

    Const BUF_SIZE As Integer = 100
    Const FIFO_SIZE As Integer = 100

    Const MDB_IF_OK As Integer = 0
    Const MDB_IF_INVALID_HANDLE As Integer = 1
    Const MDB_IF_IO_ERROR As Integer = 2
    Const MDB_IF_INVALID_PARAMETER As Integer = 3
    Const MDB_IF_NO_RESPONSE As Integer = 4
    Const MDB_IF_OTHER_ERROR As Integer = 5
    Const MDB_IF_NG As Integer = 6
    Const MDB_IF_BUSY As Integer = 7

    Const Item1_Amount As Integer = 50
    Const Item2_Amount As Integer = 135
    Const Item3_Amount As Integer = 350

    Const BlankTime As Integer = 10              ' 5sec. by 500msec periodic timer

    Private Declare Function ScanIF Lib "bvcmmdb_dll.dll" Alias "MDB_IF_ScanInterface" (ByVal comPort As Byte()) As Integer
    Private Declare Function OpenIF Lib "bvcmmdb_dll.dll" Alias "MDB_IF_OpenInterface" (ByVal comPort As Byte(), ByRef mdbIfHandle As Integer) As Integer
    Private Declare Function CloseIF Lib "bvcmmdb_dll.dll" Alias "MDB_IF_CloseInterface" (ByVal mdbIfHandle As Integer) As Integer
    Private Declare Function ExecCommand Lib "bvcmmdb_dll.dll" Alias "MDB_IF_ExecCommand" (ByVal mdbIfHandle As Integer, ByVal pucCommand() As Byte, ByVal iCommandLength As Integer, ByVal pucReceiveBuffer() As Byte, ByRef piReceiveBufferSize As Integer) As Integer
    Private Declare Function LnReset Lib "bvcmmdb_dll.dll" Alias "MDB_IF_LineReset" (ByVal mdbIfHandle As Integer) As Integer
    Private Declare Function GetVersion Lib "bvcmmdb_dll.dll" Alias "MDB_IF_GetVersion" (ByVal mdbIfHandle As Integer, ByVal pucBuffer() As Byte, ByVal iBufferSize As Integer) As Integer

    Public comPort(10) As Byte
    Dim ifHndl As Long
    Dim existsCM As Integer
    Dim existsBV As Integer
    Dim enableCM As Integer
    Dim enableBV As Integer
    Dim TotalCoinAccepted As Integer
    Dim TotalBillAccepted As Integer
    Dim CoinsDeposited(16) As Integer
    Dim BillsDeposited(16) As Integer
    Dim TotalDeposit, PTotalDeposit As Integer
    Dim Change As Integer
    Dim MaxItemAmount As Integer
    Dim MinimumItemAmount As Integer
    Dim PayingFlag As Boolean
    Dim BlankTimer As Integer
    Dim BlankTimerEnable As Boolean

    Public ChangerFeatureLevel As Byte
    Public ChangerCurrencyCode As UShort
    Public CoinScalingFactor As Byte
    Public CoinDecimalPlaces As Byte
    Public CoinTypeRouting As UShort
    Public CoinTypeCredit(16) As Byte

    Public TubeFullStatus As UShort
    Public CoinsDispensedManually(16) As Byte
    Public CoinsInTube(16) As Byte
    Public ChangerStatus As Byte
    Public ChangerSlug As Byte

    Public BillValiFeatureLevel As Byte
    Public BillValiCurrencyCode As UShort
    Public BillScalingFactor As UShort = 100
    Public BillDecimalPlaces As Byte
    Public BillStackerCapability As UShort
    Public BillSecurityLevels As UShort
    Public BillEscrowCapability As Byte
    Public BillTypeCredit(16) As Byte

    Public BillSecurity(2) As Byte

    Public StackerFullStatus As UShort
    Public BillsStacked(16) As Byte         ' Cash Box
    Public BillsAccepted(16) As Byte        ' Escrow Position
    Public BillsReturned(16) As Byte        ' Return Back
    Public BillValiStatus As Byte


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim stc As Integer
        Dim cmndlen As Integer
        Dim buf(BUF_SIZE) As Byte
        Dim rxsize As Integer
        Dim amnt As Decimal

        enableBV = False
        enableCM = False
        Label9.Text = "Accepting Cash"

        stc = ScanIF(comPort)                               ' Scan Interface
        If (comPort(0) = Asc("C")) Then
            stc = OpenIF(comPort, ifHndl)                   ' Open Interface
            If (stc = MDB_IF_OK) And (ifHndl <> 0) Then

                buf(0) = &H1                                ' Get Interface Version
                cmndlen = 1
                rxsize = BUF_SIZE
                stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)

                buf(0) = &H8                                ' Reset Coin Mech
                cmndlen = 1
                rxsize = BUF_SIZE
                stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
                If (stc = MDB_IF_OK) Then
                    existsCM = True
                Else
                    existsCM = False
                End If

                buf(0) = &H30                               ' Reset Bill Validator
                cmndlen = 1
                rxsize = BUF_SIZE
                stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
                If (stc = MDB_IF_OK) Then
                    existsBV = True
                Else
                    existsBV = False
                End If
            End If
        End If

        Thread.Sleep(3000)

        If (existsCM = True) Then

            buf(0) = &HB                                    ' Poll Coin Mech
            cmndlen = 1
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)

            buf(0) = &H9                                    ' Setup Coin Mech
            cmndlen = 1
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            ParseDataCoinSetup(buf, rxsize)

            buf(0) = &HA                                    ' Tubu Status
            cmndlen = 1
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            ParseDataTube(buf, rxsize)

        End If

        If (existsBV = True) Then

            buf(0) = &H33                                   ' Poll Bill Validator
            cmndlen = 1
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)

            buf(0) = &H31                                   ' Setup Bill Validator
            cmndlen = 1
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            ParseDataBillSetup(buf, rxsize)

            buf(0) = &H36                                   ' Stacker Information
            cmndlen = 1
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            ParseDataStacker(buf, rxsize)

        End If

        amnt = Item1_Amount / BillScalingFactor
        Label4.Text = "$" + amnt.ToString("F2")
        amnt = Item2_Amount / BillScalingFactor
        Label5.Text = "$" + amnt.ToString("F2")
        amnt = Item3_Amount / BillScalingFactor
        Label6.Text = "$" + amnt.ToString("F2")

        MinimumItemAmount = Item1_Amount
        If (MinimumItemAmount > Item2_Amount) Then MinimumItemAmount = Item2_Amount
        If (MinimumItemAmount > Item3_Amount) Then MinimumItemAmount = Item3_Amount

        MaxItemAmount = Item1_Amount
        If (MaxItemAmount < Item2_Amount) Then MaxItemAmount = Item2_Amount
        If (MaxItemAmount < Item3_Amount) Then MaxItemAmount = Item3_Amount

        AcceptCash()

        Timer1.Enabled = True

    End Sub


    Private Sub ParseDataCoinSetup(ByVal buf() As Byte, ByVal bytes As Integer)

        Dim i As Integer

        ChangerFeatureLevel = buf(0)
        ChangerCurrencyCode = buf(1) * 256 + buf(2)
        CoinScalingFactor = buf(3)
        CoinDecimalPlaces = buf(4)
        CoinTypeRouting = buf(5) * 256 + buf(6)
        For i = 0 To 15
            CoinTypeCredit(i) = buf(i + 7)
        Next

    End Sub


    Private Sub ParseDataTube(ByVal buf() As Byte, ByVal bytes As Integer)

        Dim i As Integer

        TubeFullStatus = buf(0) * 256 + buf(1)
        For i = 0 To 15
            CoinsInTube(i) = buf(i + 2)
        Next

    End Sub


    Private Sub ParseDataCoinPoll(ByVal buf() As Byte, ByVal bytes As Integer)

        Dim tmp As Byte
        Dim i As Integer = 0
        Dim payout_busy = False

        bytes = bytes - 1
        Do While bytes > 0
            If buf(i) And &H80 Then                         ' Coins Dispense Manually
                CoinsDispensedManually(buf(i) And &HF) = (buf(i) And &H70) \ 16
                CoinsInTube(buf(i) And &HF) = buf(i + 1)
                i = i + 2
                bytes = bytes - 2
            ElseIf buf(i) And &H40 Then                     ' Coins Depositted
                tmp = buf(i) And &H30
                Select Case tmp
                    Case &H0                                ' CASH BOX
                        CoinsDeposited(buf(i) And &HF) = CoinsDeposited(buf(i) And &HF) + 1
                        TotalCoinAccepted = CalcCoins()
                    Case &H10                               ' TUBE
                        CoinsDeposited(buf(i) And &HF) = CoinsDeposited(buf(i) And &HF) + 1
                        TotalCoinAccepted = CalcCoins()
                End Select
                i = i + 2
                bytes = bytes - 2
            ElseIf buf(i) And &H20 Then                     ' Slug
                ChangerSlug = buf(i) And &H1F
                i = i + 1
                bytes = bytes - 1
            Else                                            ' Status
                ChangerStatus = buf(i)
                If ChangerStatus = &H1 Then                 ' Escrow Lever
                    CancelVend()

                ElseIf ChangerStatus = &H2 Then             ' Payout Busy
                    payout_busy = True
                End If
                i = i + 1
                bytes = bytes - 1
            End If
        Loop

        If PayingFlag = True And payout_busy = False Then
            PayingFlag = False
            BlankTimer = 0              ' Kick start blank time for next operation
            BlankTimerEnable = True
        End If

    End Sub


    Private Sub ParseDataBillSetup(ByVal buf() As Byte, ByVal bytes As Integer)

        Dim i As Integer

        BillValiFeatureLevel = buf(0)
        BillValiCurrencyCode = buf(1) * 256 + buf(2)
        BillScalingFactor = buf(3) * 256 + buf(4)
        BillDecimalPlaces = buf(5)
        BillStackerCapability = buf(6) * 256 + buf(7)
        BillSecurityLevels = buf(8) * 256 + buf(9)
        BillEscrowCapability = buf(10)

        For i = 11 To 26
            If i < (bytes - 1) Then
                BillTypeCredit(i - 11) = buf(i)
            Else
                BillTypeCredit(i - 11) = 0
            End If
        Next

    End Sub


    Private Sub ParseDataStacker(ByVal buf() As Byte, ByVal bytes As Integer)

        StackerFullStatus = buf(0) * 256 + buf(1)

    End Sub


    Private Sub ParseDataBillPoll(ByVal buf() As Byte, ByVal bytes As Integer)

        Dim stc As Integer
        Dim cmndlen As Integer
        Dim cmnd(BUF_SIZE) As Byte
        Dim rxsize As Integer
        Dim tmp As Byte
        Dim i As Integer = 0

        bytes = bytes - 1
        Do While bytes > 0
            If buf(i) And &H80 Then                         ' Bill Accepted
                tmp = buf(i) And &H70
                Select Case tmp
                    Case &H0                                ' STACKED
                        BillsStacked(buf(i) And &HF) = BillsStacked(buf(i) And &HF) + 1
                        BillsAccepted(buf(i) And &HF) = BillsAccepted(buf(i) And &HF) - 1
                    Case &H10                               ' ESCROW POSITION
                        BillsAccepted(buf(i) And &HF) = BillsAccepted(buf(i) And &HF) + 1
                        cmnd(0) = &H35                      ' Stack
                        cmnd(1) = &H1
                        cmndlen = 2
                        rxsize = BUF_SIZE
                        stc = ExecCommand(ifHndl, cmnd, cmndlen, cmnd, rxsize)
                        BillsDeposited(buf(i) And &HF) = BillsDeposited(buf(i) And &HF) + 1
                        TotalBillAccepted = CalcBills()
                    Case &H20                               ' RETURNED
                        BillsReturned(buf(i) And &HF) = BillsReturned(buf(i) And &HF) + 1
                        BillsAccepted(buf(i) And &HF) = BillsAccepted(buf(i) And &HF) - 1
                End Select
                i = i + 1
                bytes = bytes - 1
            Else                                            ' Status
                BillValiStatus = buf(i)
                i = i + 1
                bytes = bytes - 1
            End If
        Loop

    End Sub


    Private Sub AcceptCash()

        Dim stc As Integer
        Dim cmndlen As Integer
        Dim buf(BUF_SIZE) As Byte
        Dim rxsize As Integer
        Dim i As Integer
        Dim tmp As UShort

        TotalDeposit = 0
        PTotalDeposit = 0
        Change = 0

        For i = 0 To 15
            BillsDeposited(i) = 0
            CoinsDeposited(i) = 0
        Next

        Button1.Enabled = False
        Button1.BackColor = Color.DarkSlateGray
        Button2.Enabled = False
        Button2.BackColor = Color.DarkSlateGray
        Button3.Enabled = False
        Button3.BackColor = Color.DarkSlateGray

        If (existsCM = True) Then

            buf(0) = &HC                                    ' Accept all types of Coin
            buf(1) = &HFF
            buf(2) = &HFF
            buf(3) = &H0
            buf(4) = &H0
            cmndlen = 5
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            If stc = MDB_IF_OK Then enableCM = True

        End If

        If (existsBV = True) Then

            buf(0) = &H34                                   ' Accept all types of Bill
            For i = 0 To 15
                tmp = tmp >> 1
                If BillTypeCredit(i) <> 0 Then tmp = tmp Or &H8000
            Next
            buf(1) = &HFF
            buf(2) = &HFF
            buf(3) = &H0
            buf(4) = &H0
            cmndlen = 5
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            If stc = MDB_IF_OK Then enableBV = True

        End If

        BlankTimerEnable = False

    End Sub


    Private Sub DeacceptCash()

        Dim stc As Integer
        Dim cmndlen As Integer
        Dim buf(BUF_SIZE) As Byte
        Dim rxsize As Integer
        Dim i As Integer
        Dim tmp As UShort

        If (existsCM = True) Then

            buf(0) = &HC                                    ' Accept all types of Coin
            buf(1) = &H0
            buf(2) = &H0
            buf(3) = &H0
            buf(4) = &H0
            cmndlen = 5
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            If stc = MDB_IF_OK Then enableCM = False

        End If

        If (existsBV = True) Then

            buf(0) = &H34                                   ' Accept all types of Bill
            For i = 0 To 15
                tmp = tmp >> 1
                If BillTypeCredit(i) <> 0 Then tmp = tmp Or &H8000
            Next
            buf(1) = &H0
            buf(2) = &H0
            buf(3) = &H0
            buf(4) = &H0
            cmndlen = 5
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            If stc = MDB_IF_OK Then enableBV = False

        End If

        BlankTimerEnable = False

    End Sub

    Function CalcCoins() As Integer

        Dim i As Integer
        Dim tmp As UShort = &H1
        Dim total As Integer = 0

        For i = 0 To 15
            If (CoinTypeRouting And tmp) <> 0 Then
                total = total + CoinsDeposited(i) * CoinTypeCredit(i) * CoinScalingFactor
            End If
            tmp = tmp << 1
        Next

        Return total
    End Function


    Function CalcBills() As Integer

        Dim i As Integer
        Dim tmp As UShort = &H1
        Dim total As Integer = 0

        For i = 0 To 15
            If BillsDeposited(i) <> 0 Then
                total = total + BillsDeposited(i) * BillTypeCredit(i) * BillScalingFactor
            End If
        Next

        Return total
    End Function


    Sub PayChange(ByVal chg As Integer)

        Dim stc As Integer
        Dim cmndlen As Integer
        Dim buf(BUF_SIZE) As Byte
        Dim rxsize As Integer
        Dim doller As Byte
        Dim quater As Byte
        Dim dime As Byte
        Dim nikkel As Byte
        Dim c_type As Byte
        Dim i As Integer

        PayingFlag = False
        doller = chg \ 100
        chg = chg - doller * 100
        quater = chg \ 25
        chg = chg - quater * 25
        dime = chg \ 10
        chg = chg - dime * 10
        nikkel = chg \ 5
        chg = chg - nikkel * 10

        If existsCM = True Then

            If doller > 0 Then
                c_type = 15
                For i = 0 To 15
                    If CoinTypeCredit(i) = 20 Then
                        c_type = i
                    End If
                Next
                If c_type <> 15 Then
                    PayingFlag = True
                    buf(0) = &HD
                    buf(1) = (doller << 4) Or c_type
                    cmndlen = 2
                    rxsize = BUF_SIZE
                    stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
                End If
            End If

            If quater > 0 Then
                c_type = 15
                For i = 0 To 15
                    If CoinTypeCredit(i) = 5 Then
                        c_type = i
                    End If
                Next
                If c_type <> 15 Then
                    PayingFlag = True
                    buf(0) = &HD
                    buf(1) = (quater << 4) Or &H2
                    cmndlen = 2
                    rxsize = BUF_SIZE
                    stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
                End If
            End If

            If dime > 0 Then
                c_type = 15
                For i = 0 To 15
                    If CoinTypeCredit(i) = 2 Then
                        c_type = i
                    End If
                Next
                If c_type <> 15 Then
                    PayingFlag = True
                    buf(0) = &HD
                    buf(1) = (dime << 4) Or &H1
                    cmndlen = 2
                    rxsize = BUF_SIZE
                    stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
                End If
            End If

            If nikkel > 0 Then
                c_type = 15
                For i = 0 To 15
                    If CoinTypeCredit(i) = 1 Then
                        c_type = i
                    End If
                Next
                If c_type <> 15 Then
                    PayingFlag = True
                    buf(0) = &HD
                    buf(1) = (nikkel << 4)
                    cmndlen = 2
                    rxsize = BUF_SIZE
                    stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
                End If
            End If

        End If

        If PayingFlag = False Then      ' If no change
            BlankTimer = 0              ' Kick start blank time for next operation
            BlankTimerEnable = True
        End If

    End Sub


    Private Sub CancelVend()

        Dim disp As Decimal

        If PTotalDeposit = 0 Then Return

        DeacceptCash()
        Button1.Enabled = False
        Button1.BackColor = Color.DarkSlateGray
        Button2.Enabled = False
        Button2.BackColor = Color.DarkSlateGray
        Button3.Enabled = False
        Button3.BackColor = Color.DarkSlateGray

        Label9.Text = "Canceling ..."

        Change = TotalDeposit
        disp = Change / BillScalingFactor
        TextBox2.Text = disp.ToString("F2")

        PayChange(Change)

        TotalDeposit = 0
        TotalCoinAccepted = 0
        TotalBillAccepted = 0

        disp = TotalDeposit / BillScalingFactor
        TextBox1.Text = disp.ToString("F2")
        PTotalDeposit = TotalDeposit

    End Sub


    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick

        Dim stc As Integer
        Dim cmndlen As Integer
        Dim buf(BUF_SIZE) As Byte
        Dim rxsize As Integer
        Dim disp As Decimal

        If BlankTimerEnable = True Then                 ' Restart Operation Blank Time
            If BlankTimer < BlankTime Then
                BlankTimer = BlankTimer + 1
            Else
                Label9.Text = "Accepting Cash"
                TextBox2.Text = "0.00"
                AcceptCash()
            End If
        End If

        If (existsCM = True) Then
            buf(0) = &HB                                ' Poll Coin Mech
            cmndlen = 1
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            ParseDataCoinPoll(buf, rxsize)
        End If

        If (existsBV = True) Then
            buf(0) = &H33                               ' Poll Bill Validator
            cmndlen = 1
            rxsize = BUF_SIZE
            stc = ExecCommand(ifHndl, buf, cmndlen, buf, rxsize)
            ParseDataBillPoll(buf, rxsize)
        End If

        TotalDeposit = TotalCoinAccepted + TotalBillAccepted
        If PTotalDeposit <> TotalDeposit Then

            disp = TotalDeposit / BillScalingFactor
            TextBox1.Text = disp.ToString("F2")
            PTotalDeposit = TotalDeposit

            If TotalDeposit >= Item1_Amount Then
                Button1.Enabled = True
                Button1.BackColor = Color.DodgerBlue
            End If

            If TotalDeposit >= Item2_Amount Then
                Button2.Enabled = True
                Button2.BackColor = Color.DodgerBlue
            End If

            If TotalDeposit >= Item3_Amount Then
                Button3.Enabled = True
                Button3.BackColor = Color.DodgerBlue
            End If

            If TotalDeposit >= MinimumItemAmount Then
                Label9.Text = "Press Item Button."
            ElseIf TotalDeposit >= MaxItemAmount Then
                DeacceptCash()
            End If

        End If

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim disp As Decimal

        DeacceptCash()
        Button1.Enabled = False
        Button1.BackColor = Color.DarkSlateGray
        Button2.Enabled = False
        Button2.BackColor = Color.DarkSlateGray
        Button3.Enabled = False
        Button3.BackColor = Color.DarkSlateGray

        ' Vend here
        Label9.Text = "Thank you for buying ..."

        Change = TotalDeposit - Item1_Amount
        disp = Change / BillScalingFactor
        TextBox2.Text = disp.ToString("F2")

        PayChange(Change)

        TotalDeposit = 0
        TotalCoinAccepted = 0
        TotalBillAccepted = 0

        disp = TotalDeposit / BillScalingFactor
        TextBox1.Text = disp.ToString("F2")
        PTotalDeposit = TotalDeposit

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        Dim disp As Decimal

        DeacceptCash()
        Button1.Enabled = False
        Button1.BackColor = Color.DarkSlateGray
        Button2.Enabled = False
        Button2.BackColor = Color.DarkSlateGray
        Button3.Enabled = False
        Button3.BackColor = Color.DarkSlateGray

        ' Vend here
        Label9.Text = "Thank you for buying ..."

        Change = TotalDeposit - Item2_Amount
        disp = Change / BillScalingFactor
        TextBox2.Text = disp.ToString("F2")

        PayChange(Change)

        TotalDeposit = 0
        TotalCoinAccepted = 0
        TotalBillAccepted = 0

        disp = TotalDeposit / BillScalingFactor
        TextBox1.Text = disp.ToString("F2")
        PTotalDeposit = TotalDeposit

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click

        Dim disp As Decimal

        DeacceptCash()
        Button1.Enabled = False
        Button1.BackColor = Color.DarkSlateGray
        Button2.Enabled = False
        Button2.BackColor = Color.DarkSlateGray
        Button3.Enabled = False
        Button3.BackColor = Color.DarkSlateGray

        ' Vend here
        Label9.Text = "Thank you for buying ..."

        Change = TotalDeposit - Item3_Amount
        disp = Change / BillScalingFactor
        TextBox2.Text = disp.ToString("F2")

        PayChange(Change)

        TotalDeposit = 0
        TotalCoinAccepted = 0
        TotalBillAccepted = 0

        disp = TotalDeposit / BillScalingFactor
        TextBox1.Text = disp.ToString("F2")
        PTotalDeposit = TotalDeposit

    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing

        DeacceptCash()

    End Sub
End Class
